* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2016-02-11 9:28 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2016-02-11 9:28 UTC (permalink / raw
To: gentoo-commits
commit: ebc8b4c9463f8d21a0e8c238240c60eefb81227e
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Thu Feb 11 09:26:10 2016 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Thu Feb 11 09:26:10 2016 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=ebc8b4c9
sys-libs/libcxx: bump version
Package-Manager: portage-2.2.20-prefix
sys-libs/libcxx/Manifest | 1 +
sys-libs/libcxx/libcxx-3.7.1.ebuild | 235 ++++++++++++++++++++++++++++++++++++
2 files changed, 236 insertions(+)
diff --git a/sys-libs/libcxx/Manifest b/sys-libs/libcxx/Manifest
index af61856..15398c2 100644
--- a/sys-libs/libcxx/Manifest
+++ b/sys-libs/libcxx/Manifest
@@ -1,2 +1,3 @@
DIST libcxx-3.5.1.src.tar.xz 912248 SHA256 a16d0ae0c0cf2c8cebb94fafcb907022cd4f8579ebac99a4c9919990a37ad475 SHA512 3be33787c79aa5d03a3f507be20ef986215d6008e4f0370e3c5906d76a620bf27c9ed4c35f4561c1ac507a1b217fa7fc7577611e7205f3f2433c677bf86b8632 WHIRLPOOL 725892f113a918168b8ae8b5e93401130ccb1080c207445ba943c4fc06e481002939d37cfbbb59dc2791f91ccd7c673274ee523ec96418ed04ca22c8d11e2bec
DIST libcxx-3.6.2.src.tar.xz 944020 SHA256 52f3d452f48209c9df1792158fdbd7f3e98ed9bca8ebb51fcd524f67437c8b81 SHA512 1eb575921ca0d636c4b7ba21b3ad2c09468d779c69b3106ceefde294344cf20a48a03f9d38ea0db9f8b909f56f0fd1a56a255101305318e04d9f2d20af358ba6 WHIRLPOOL ec225d10cbfe3ca5eba2ed5f16ac6c19914ee75d71db2a1d8ca30f326c9fd5576899361f4397f2ee5d09dd3e8abaca82080c63e303b90d6f19f755465a11a065
+DIST libcxx-3.7.1.src.tar.xz 995724 SHA256 357fbd4288ce99733ba06ae2bec6f503413d258aeebaab8b6a791201e6f7f144 SHA512 08d2399a8b36aa15290733256c896c9fa43f1a1223bc5c73bbcd014fddf8880e514d2a6dcc456bcf18b537c01fb6911b092e6d9958bccd8e64e9f375ed7a1ab9 WHIRLPOOL 19f77946abf48cbdd3e7ea21fd009ca3cc5f607dfe0512a44b102847044bb1d5ae4b16f503f18b14ebd9ea115256e87af07409907ba2a65f6061e217a502a359
diff --git a/sys-libs/libcxx/libcxx-3.7.1.ebuild b/sys-libs/libcxx/libcxx-3.7.1.ebuild
new file mode 100644
index 0000000..0fdf949
--- /dev/null
+++ b/sys-libs/libcxx/libcxx-3.7.1.ebuild
@@ -0,0 +1,235 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: $
+
+EAPI=5
+
+ESVN_REPO_URI="http://llvm.org/svn/llvm-project/libcxx/trunk"
+
+[ "${PV%9999}" != "${PV}" ] && SCM="subversion" || SCM=""
+
+inherit ${SCM} flag-o-matic toolchain-funcs multilib multilib-minimal
+
+DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
+HOMEPAGE="http://libcxx.llvm.org/"
+if [ "${PV%9999}" = "${PV}" ] ; then
+ SRC_URI="mirror://gentoo/${P}.src.tar.xz
+ http://llvm.org/releases/${PV}/${P}.src.tar.xz"
+ S="${WORKDIR}"/"${P}".src
+else
+ SRC_URI=""
+fi
+
+LICENSE="|| ( UoI-NCSA MIT )"
+SLOT="0"
+if [ "${PV%9999}" = "${PV}" ] ; then
+ KEYWORDS="~x64-macos ~x86-macos"
+else
+ KEYWORDS=""
+fi
+IUSE="elibc_glibc +libcxxrt static-libs test"
+
+REQUIRED_USE="kernel_Darwin? ( libcxxrt !static-libs )"
+RDEPEND="!kernel_Darwin? (
+ libcxxrt? ( >=sys-libs/libcxxrt-0.0_p20130725[static-libs?,${MULTILIB_USEDEP}] )
+ !libcxxrt? ( >=sys-devel/gcc-4.7[cxx] ) )
+ kernel_Darwin? ( sys-libs/libcxx-headers sys-libs/libcxxabi sys-devel/clang )"
+DEPEND="${RDEPEND}
+ test? ( sys-devel/clang )
+ app-arch/xz-utils"
+
+DOCS=( CREDITS.TXT )
+
+pkg_setup() {
+ if [[ ${CHOST} == *darwin* ]] ; then
+ MY_CC=$(tc-getCC)
+ MY_CXX=$(tc-getCXX)
+ if [[ ${MY_CC} != *clang* || ${MY_CXX} != *clang++* ]] ; then
+ eerror "${PN} needs to be built with clang++. Please do not override"
+ eerror "CC ($MY_CC) and CXX ($MY_CXX)"
+ eerror "or point them at clang and clang++ respectively."
+ die
+ fi
+ return
+ fi
+ if ! use libcxxrt ; then
+ ewarn "You have disabled USE=libcxxrt. This will build ${PN} against"
+ ewarn "libsupc++. Please note that this is not well supported."
+ ewarn "In particular, static linking will not work."
+ fi
+ if [[ $(gcc-version) < 4.7 ]] && [[ $(tc-getCXX) != *clang++* ]] ; then
+ eerror "${PN} needs to be built with clang++ or gcc-4.7 or later."
+ eerror "Please use gcc-config to switch to gcc-4.7 or later version."
+ die
+ fi
+}
+
+src_prepare() {
+ cp -f "${FILESDIR}/Makefile" lib/ || die
+
+ if [[ ${CHOST} == *darwin* ]] ; then
+ epatch "${FILESDIR}"/${PN}-3.5.1-olddarwin.patch
+
+ [[ "${CHOST##*-darwin}" -le 10 ]] && \
+ epatch "${FILESDIR}"/${PN}-3.5.1-cmath-conv.patch
+
+ # libc++abi needs stack unwinding functions provided by libSystem on
+ # Mac OS X >= 10.6. On < 10.6 they're in libgcc_s. So force link
+ # against that. Additionally, the crt1.o provided by our gcc-apple
+ # toolchain isn't universal. Since that's needed for linking any
+ # program on OS X < 10.7, universal support is effectively broken on
+ # those older OS Xes even if clang and libc++{,abi} were to support it.
+ # So we can just disable universal compilation.
+ gcc_s=gcc_s.1
+ [[ "${CHOST##*-darwin}" -eq 9 ]] && gcc_s=gcc_s.10.5
+ [[ "${CHOST##*-darwin}" -eq 8 ]] && gcc_s=gcc_s.10.4
+ [[ "${CHOST##*-darwin}" -le 9 ]] && \
+ sed -i -e "s,/usr/lib/libSystem.B.dylib,-lSystem -l${gcc_s},g" \
+ -e "s,-arch i386 -arch x86_64,,g" \
+ lib/buildit
+
+ if [[ "${CHOST##*-darwin}" -le 8 ]] ; then
+ epatch "${FILESDIR}"/${PN}-3.5.1-availability.patch
+ epatch "${FILESDIR}"/${PN}-3.5.1-eprintf.patch
+ fi
+
+ # fix library install names
+ sed -i \
+ -e "s,/usr/lib/libc++abi\.dylib,${EPREFIX}/usr/lib/libc++abi.dylib,g" \
+ -e "s,/usr/lib/libc++\.1\.dylib,${EPREFIX}/usr/lib/libc++.1.dylib,g" \
+ lib/buildit
+ fi
+
+ multilib_copy_sources
+}
+
+src_configure() {
+ tc-export AR CC CXX
+
+ # on Darwin we're all set
+ [[ ${CHOST} == *darwin* ]] && return
+
+ export LIBS="-lpthread -lrt -lc -lgcc_s"
+ if use libcxxrt ; then
+ append-cppflags -DLIBCXXRT "-I${EPREFIX}/usr/include/libcxxrt/"
+ LIBS="-lcxxrt ${LIBS}"
+ cp "${EPREFIX}/usr/include/libcxxrt/"*.h "${S}/include"
+ else
+ # Very hackish, see $HOMEPAGE
+ # If someone has a clever idea, please share it!
+ local includes="$(echo | ${CHOST}-g++ -Wp,-v -x c++ - -fsyntax-only 2>&1 | grep -C 2 '#include.*<...>' | tail -n 2 | sed -e 's/^ /-I/' | tr '\n' ' ')"
+ local libcxx_gcc_dirs="$(echo | ${CHOST}-g++ -Wp,-v -x c++ - -fsyntax-only 2>&1 | grep -C 2 '#include.*<...>' | tail -n 2 | tr '\n' ' ')"
+ append-cppflags -D__GLIBCXX__ ${includes}
+ LIBS="-lsupc++ ${LIBS}"
+ local libsupcxx_includes="cxxabi.h bits/c++config.h bits/os_defines.h bits/cpu_defines.h bits/cxxabi_tweaks.h bits/cxxabi_forced.h"
+ for i in ${libsupcxx_includes} ; do
+ local found=""
+ [ -d "${S}/include/$(dirname ${i})/" ] || mkdir -p "${S}/include/$(dirname ${i})"
+ for j in ${libcxx_gcc_dirs} ; do
+ if [ -f "${j}/${i}" ] ; then
+ cp "${j}/${i}" "${S}/include/$(dirname ${i})/" || die
+ found=yes
+ fi
+ done
+ [ -n "${found}" ] || die "Header not found: ${i}"
+ done
+ fi
+
+ append-ldflags "-Wl,-z,defs" # make sure we are not underlinked
+}
+
+multilib_src_compile() {
+ cd "${BUILD_DIR}/lib" || die
+ if [[ ${CHOST} == *darwin* ]] ; then
+ TRIPLE=-apple- ./buildit || die
+ return
+ fi
+
+ emake shared
+ use static-libs && emake static
+}
+
+# Tests fail for now, if anybody is able to fix them, help is very welcome.
+multilib_src_test() {
+ cd "${BUILD_DIR}/test"
+ LD_LIBRARY_PATH="${BUILD_DIR}/lib:${LD_LIBRARY_PATH}" \
+ CC="clang++ $(get_abi_CFLAGS) ${CXXFLAGS}" \
+ HEADER_INCLUDE="-I${BUILD_DIR}/include" \
+ SOURCE_LIB="-L${BUILD_DIR}/lib" \
+ LIBS="-lm $(usex libcxxrt -lcxxrt "")" \
+ ./testit || die
+ # TODO: fix link against libsupc++
+}
+
+# Usage: deps
+gen_ldscript() {
+ local output_format
+ output_format=$($(tc-getCC) ${CFLAGS} ${LDFLAGS} -Wl,--verbose 2>&1 | sed -n 's/^OUTPUT_FORMAT("\([^"]*\)",.*/\1/p')
+ [[ -n ${output_format} ]] && output_format="OUTPUT_FORMAT ( ${output_format} )"
+
+ cat <<-END_LDSCRIPT
+/* GNU ld script
+ Include missing dependencies
+*/
+${output_format}
+GROUP ( $@ )
+END_LDSCRIPT
+}
+
+gen_static_ldscript() {
+ if use libcxxrt ; then
+ # Move it first.
+ mv "${ED}/usr/$(get_libdir)/libc++.a" "${ED}/usr/$(get_libdir)/libc++_static.a" || die
+
+ # Generate libc++.a ldscript for inclusion of its dependencies so that
+ # clang++ -stdlib=libc++ -static works out of the box.
+ local deps="${EPREFIX}/usr/$(get_libdir)/libc++_static.a ${EPREFIX}/usr/$(get_libdir)/libcxxrt.a"
+ # On Linux/glibc it does not link without libpthread or libdl. It is
+ # fine on FreeBSD.
+ use elibc_glibc && deps="${deps} ${EPREFIX}/usr/$(get_libdir)/libpthread.a ${EPREFIX}/usr/$(get_libdir)/libdl.a"
+
+ gen_ldscript "${deps}" > "${ED}/usr/$(get_libdir)/libc++.a"
+ fi
+ # TODO: Generate a libc++.a ldscript when building against libsupc++
+}
+
+gen_shared_ldscript() {
+ if use libcxxrt ; then
+ mv "${ED}/usr/$(get_libdir)/libc++.so" "${ED}/usr/$(get_libdir)/libc++_shared.so" || die
+ local deps="${EPREFIX}/usr/$(get_libdir)/libc++_shared.so ${EPREFIX}/usr/$(get_libdir)/libcxxrt.so"
+ gen_ldscript "${deps}" > "${ED}/usr/$(get_libdir)/libc++.so"
+ fi
+ # TODO: Generate the linker script for other confiurations too.
+}
+
+multilib_src_install() {
+ cd "${BUILD_DIR}/lib"
+ if [[ ${CHOST} == *darwin* ]] ; then
+ dolib.so libc++*dylib
+ return
+ fi
+
+ if use static-libs ; then
+ dolib.a libc++.a
+ gen_static_ldscript
+ fi
+ dolib.so libc++.so*
+ gen_shared_ldscript
+}
+
+multilib_src_install_all() {
+ einstalldocs
+ # libc++abi needs the libc++ headers and we need libc++abi so the headers
+ # are already installed
+ [[ ${CHOST} == *darwin* ]] && return
+ insinto /usr/include/c++/v1
+ doins -r include/*
+}
+
+pkg_postinst() {
+ elog "This package (${PN}) is mainly intended as a replacement for the C++"
+ elog "standard library when using clang."
+ elog "To use it, instead of libstdc++, use:"
+ elog " clang++ -stdlib=libc++"
+ elog "to compile your C++ programs."
+}
^ permalink raw reply related [flat|nested] 12+ messages in thread
* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2016-02-11 9:41 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2016-02-11 9:41 UTC (permalink / raw
To: gentoo-commits
commit: 0e884f0069307645819d240a1c3133c398a19bb3
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Thu Feb 11 09:41:24 2016 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Thu Feb 11 09:41:24 2016 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=0e884f00
sys-libs/libcxx: sync with gx86
Package-Manager: portage-2.2.20-prefix
sys-libs/libcxx/libcxx-3.5.1.ebuild | 19 ++++++++++++-------
sys-libs/libcxx/libcxx-3.7.1.ebuild | 21 +++++++++++++--------
sys-libs/libcxx/metadata.xml | 3 +++
3 files changed, 28 insertions(+), 15 deletions(-)
diff --git a/sys-libs/libcxx/libcxx-3.5.1.ebuild b/sys-libs/libcxx/libcxx-3.5.1.ebuild
index 0fdf949..787a678 100644
--- a/sys-libs/libcxx/libcxx-3.5.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.5.1.ebuild
@@ -1,6 +1,6 @@
-# Copyright 1999-2015 Gentoo Foundation
+# Copyright 1999-2016 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-# $Header: $
+# $Id $
EAPI=5
@@ -13,8 +13,7 @@ inherit ${SCM} flag-o-matic toolchain-funcs multilib multilib-minimal
DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
HOMEPAGE="http://libcxx.llvm.org/"
if [ "${PV%9999}" = "${PV}" ] ; then
- SRC_URI="mirror://gentoo/${P}.src.tar.xz
- http://llvm.org/releases/${PV}/${P}.src.tar.xz"
+ SRC_URI="http://llvm.org/releases/${PV}/${P}.src.tar.xz"
S="${WORKDIR}"/"${P}".src
else
SRC_URI=""
@@ -30,10 +29,16 @@ fi
IUSE="elibc_glibc +libcxxrt static-libs test"
REQUIRED_USE="kernel_Darwin? ( libcxxrt !static-libs )"
-RDEPEND="!kernel_Darwin? (
+RDEPEND="
+ !kernel_Darwin? (
libcxxrt? ( >=sys-libs/libcxxrt-0.0_p20130725[static-libs?,${MULTILIB_USEDEP}] )
- !libcxxrt? ( >=sys-devel/gcc-4.7[cxx] ) )
- kernel_Darwin? ( sys-libs/libcxx-headers sys-libs/libcxxabi sys-devel/clang )"
+ !libcxxrt? ( >=sys-devel/gcc-4.7[cxx] )
+ )
+ kernel_Darwin? (
+ =sys-libs/libcxx-headers-${PV}
+ =sys-libs/libcxxabi-${PV}
+ sys-devel/clang
+ )"
DEPEND="${RDEPEND}
test? ( sys-devel/clang )
app-arch/xz-utils"
diff --git a/sys-libs/libcxx/libcxx-3.7.1.ebuild b/sys-libs/libcxx/libcxx-3.7.1.ebuild
index 0fdf949..10fac31 100644
--- a/sys-libs/libcxx/libcxx-3.7.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.7.1.ebuild
@@ -1,6 +1,6 @@
-# Copyright 1999-2015 Gentoo Foundation
+# Copyright 1999-2016 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-# $Header: $
+# $Id $
EAPI=5
@@ -13,9 +13,8 @@ inherit ${SCM} flag-o-matic toolchain-funcs multilib multilib-minimal
DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
HOMEPAGE="http://libcxx.llvm.org/"
if [ "${PV%9999}" = "${PV}" ] ; then
- SRC_URI="mirror://gentoo/${P}.src.tar.xz
- http://llvm.org/releases/${PV}/${P}.src.tar.xz"
- S="${WORKDIR}"/"${P}".src
+ SRC_URI="http://llvm.org/releases/${PV}/${P}.src.tar.xz"
+ S="${WORKDIR}/${P}.src"
else
SRC_URI=""
fi
@@ -30,10 +29,16 @@ fi
IUSE="elibc_glibc +libcxxrt static-libs test"
REQUIRED_USE="kernel_Darwin? ( libcxxrt !static-libs )"
-RDEPEND="!kernel_Darwin? (
+RDEPEND="
+ !kernel_Darwin? (
libcxxrt? ( >=sys-libs/libcxxrt-0.0_p20130725[static-libs?,${MULTILIB_USEDEP}] )
- !libcxxrt? ( >=sys-devel/gcc-4.7[cxx] ) )
- kernel_Darwin? ( sys-libs/libcxx-headers sys-libs/libcxxabi sys-devel/clang )"
+ !libcxxrt? ( >=sys-devel/gcc-4.7[cxx] )
+ )
+ kernel_Darwin? (
+ =sys-libs/libcxx-headers-${PV}
+ =sys-libs/libcxxabi-${PV}
+ sys-devel/clang
+ )"
DEPEND="${RDEPEND}
test? ( sys-devel/clang )
app-arch/xz-utils"
diff --git a/sys-libs/libcxx/metadata.xml b/sys-libs/libcxx/metadata.xml
index f737f23..6795d17 100644
--- a/sys-libs/libcxx/metadata.xml
+++ b/sys-libs/libcxx/metadata.xml
@@ -2,4 +2,7 @@
<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
<pkgmetadata>
<herd>prefix</herd>
+ <use>
+ <flag name="libcxxrt">Build against <pkg>sys-libs/libcxxr</pkg></flag>
+ </use>
</pkgmetadata>
^ permalink raw reply related [flat|nested] 12+ messages in thread
* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2016-02-11 9:41 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2016-02-11 9:41 UTC (permalink / raw
To: gentoo-commits
commit: c18ebc15ea9a8ba21aed3c05870001139b7673f6
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Thu Feb 11 09:34:37 2016 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Thu Feb 11 09:34:37 2016 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=c18ebc15
sys-libs/libcxx: drop unused version
Package-Manager: portage-2.2.20-prefix
sys-libs/libcxx/Manifest | 1 -
sys-libs/libcxx/libcxx-3.6.2.ebuild | 235 ------------------------------------
2 files changed, 236 deletions(-)
diff --git a/sys-libs/libcxx/Manifest b/sys-libs/libcxx/Manifest
index 15398c2..11bf65d 100644
--- a/sys-libs/libcxx/Manifest
+++ b/sys-libs/libcxx/Manifest
@@ -1,3 +1,2 @@
DIST libcxx-3.5.1.src.tar.xz 912248 SHA256 a16d0ae0c0cf2c8cebb94fafcb907022cd4f8579ebac99a4c9919990a37ad475 SHA512 3be33787c79aa5d03a3f507be20ef986215d6008e4f0370e3c5906d76a620bf27c9ed4c35f4561c1ac507a1b217fa7fc7577611e7205f3f2433c677bf86b8632 WHIRLPOOL 725892f113a918168b8ae8b5e93401130ccb1080c207445ba943c4fc06e481002939d37cfbbb59dc2791f91ccd7c673274ee523ec96418ed04ca22c8d11e2bec
-DIST libcxx-3.6.2.src.tar.xz 944020 SHA256 52f3d452f48209c9df1792158fdbd7f3e98ed9bca8ebb51fcd524f67437c8b81 SHA512 1eb575921ca0d636c4b7ba21b3ad2c09468d779c69b3106ceefde294344cf20a48a03f9d38ea0db9f8b909f56f0fd1a56a255101305318e04d9f2d20af358ba6 WHIRLPOOL ec225d10cbfe3ca5eba2ed5f16ac6c19914ee75d71db2a1d8ca30f326c9fd5576899361f4397f2ee5d09dd3e8abaca82080c63e303b90d6f19f755465a11a065
DIST libcxx-3.7.1.src.tar.xz 995724 SHA256 357fbd4288ce99733ba06ae2bec6f503413d258aeebaab8b6a791201e6f7f144 SHA512 08d2399a8b36aa15290733256c896c9fa43f1a1223bc5c73bbcd014fddf8880e514d2a6dcc456bcf18b537c01fb6911b092e6d9958bccd8e64e9f375ed7a1ab9 WHIRLPOOL 19f77946abf48cbdd3e7ea21fd009ca3cc5f607dfe0512a44b102847044bb1d5ae4b16f503f18b14ebd9ea115256e87af07409907ba2a65f6061e217a502a359
diff --git a/sys-libs/libcxx/libcxx-3.6.2.ebuild b/sys-libs/libcxx/libcxx-3.6.2.ebuild
deleted file mode 100644
index 0fdf949..0000000
--- a/sys-libs/libcxx/libcxx-3.6.2.ebuild
+++ /dev/null
@@ -1,235 +0,0 @@
-# Copyright 1999-2015 Gentoo Foundation
-# Distributed under the terms of the GNU General Public License v2
-# $Header: $
-
-EAPI=5
-
-ESVN_REPO_URI="http://llvm.org/svn/llvm-project/libcxx/trunk"
-
-[ "${PV%9999}" != "${PV}" ] && SCM="subversion" || SCM=""
-
-inherit ${SCM} flag-o-matic toolchain-funcs multilib multilib-minimal
-
-DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
-HOMEPAGE="http://libcxx.llvm.org/"
-if [ "${PV%9999}" = "${PV}" ] ; then
- SRC_URI="mirror://gentoo/${P}.src.tar.xz
- http://llvm.org/releases/${PV}/${P}.src.tar.xz"
- S="${WORKDIR}"/"${P}".src
-else
- SRC_URI=""
-fi
-
-LICENSE="|| ( UoI-NCSA MIT )"
-SLOT="0"
-if [ "${PV%9999}" = "${PV}" ] ; then
- KEYWORDS="~x64-macos ~x86-macos"
-else
- KEYWORDS=""
-fi
-IUSE="elibc_glibc +libcxxrt static-libs test"
-
-REQUIRED_USE="kernel_Darwin? ( libcxxrt !static-libs )"
-RDEPEND="!kernel_Darwin? (
- libcxxrt? ( >=sys-libs/libcxxrt-0.0_p20130725[static-libs?,${MULTILIB_USEDEP}] )
- !libcxxrt? ( >=sys-devel/gcc-4.7[cxx] ) )
- kernel_Darwin? ( sys-libs/libcxx-headers sys-libs/libcxxabi sys-devel/clang )"
-DEPEND="${RDEPEND}
- test? ( sys-devel/clang )
- app-arch/xz-utils"
-
-DOCS=( CREDITS.TXT )
-
-pkg_setup() {
- if [[ ${CHOST} == *darwin* ]] ; then
- MY_CC=$(tc-getCC)
- MY_CXX=$(tc-getCXX)
- if [[ ${MY_CC} != *clang* || ${MY_CXX} != *clang++* ]] ; then
- eerror "${PN} needs to be built with clang++. Please do not override"
- eerror "CC ($MY_CC) and CXX ($MY_CXX)"
- eerror "or point them at clang and clang++ respectively."
- die
- fi
- return
- fi
- if ! use libcxxrt ; then
- ewarn "You have disabled USE=libcxxrt. This will build ${PN} against"
- ewarn "libsupc++. Please note that this is not well supported."
- ewarn "In particular, static linking will not work."
- fi
- if [[ $(gcc-version) < 4.7 ]] && [[ $(tc-getCXX) != *clang++* ]] ; then
- eerror "${PN} needs to be built with clang++ or gcc-4.7 or later."
- eerror "Please use gcc-config to switch to gcc-4.7 or later version."
- die
- fi
-}
-
-src_prepare() {
- cp -f "${FILESDIR}/Makefile" lib/ || die
-
- if [[ ${CHOST} == *darwin* ]] ; then
- epatch "${FILESDIR}"/${PN}-3.5.1-olddarwin.patch
-
- [[ "${CHOST##*-darwin}" -le 10 ]] && \
- epatch "${FILESDIR}"/${PN}-3.5.1-cmath-conv.patch
-
- # libc++abi needs stack unwinding functions provided by libSystem on
- # Mac OS X >= 10.6. On < 10.6 they're in libgcc_s. So force link
- # against that. Additionally, the crt1.o provided by our gcc-apple
- # toolchain isn't universal. Since that's needed for linking any
- # program on OS X < 10.7, universal support is effectively broken on
- # those older OS Xes even if clang and libc++{,abi} were to support it.
- # So we can just disable universal compilation.
- gcc_s=gcc_s.1
- [[ "${CHOST##*-darwin}" -eq 9 ]] && gcc_s=gcc_s.10.5
- [[ "${CHOST##*-darwin}" -eq 8 ]] && gcc_s=gcc_s.10.4
- [[ "${CHOST##*-darwin}" -le 9 ]] && \
- sed -i -e "s,/usr/lib/libSystem.B.dylib,-lSystem -l${gcc_s},g" \
- -e "s,-arch i386 -arch x86_64,,g" \
- lib/buildit
-
- if [[ "${CHOST##*-darwin}" -le 8 ]] ; then
- epatch "${FILESDIR}"/${PN}-3.5.1-availability.patch
- epatch "${FILESDIR}"/${PN}-3.5.1-eprintf.patch
- fi
-
- # fix library install names
- sed -i \
- -e "s,/usr/lib/libc++abi\.dylib,${EPREFIX}/usr/lib/libc++abi.dylib,g" \
- -e "s,/usr/lib/libc++\.1\.dylib,${EPREFIX}/usr/lib/libc++.1.dylib,g" \
- lib/buildit
- fi
-
- multilib_copy_sources
-}
-
-src_configure() {
- tc-export AR CC CXX
-
- # on Darwin we're all set
- [[ ${CHOST} == *darwin* ]] && return
-
- export LIBS="-lpthread -lrt -lc -lgcc_s"
- if use libcxxrt ; then
- append-cppflags -DLIBCXXRT "-I${EPREFIX}/usr/include/libcxxrt/"
- LIBS="-lcxxrt ${LIBS}"
- cp "${EPREFIX}/usr/include/libcxxrt/"*.h "${S}/include"
- else
- # Very hackish, see $HOMEPAGE
- # If someone has a clever idea, please share it!
- local includes="$(echo | ${CHOST}-g++ -Wp,-v -x c++ - -fsyntax-only 2>&1 | grep -C 2 '#include.*<...>' | tail -n 2 | sed -e 's/^ /-I/' | tr '\n' ' ')"
- local libcxx_gcc_dirs="$(echo | ${CHOST}-g++ -Wp,-v -x c++ - -fsyntax-only 2>&1 | grep -C 2 '#include.*<...>' | tail -n 2 | tr '\n' ' ')"
- append-cppflags -D__GLIBCXX__ ${includes}
- LIBS="-lsupc++ ${LIBS}"
- local libsupcxx_includes="cxxabi.h bits/c++config.h bits/os_defines.h bits/cpu_defines.h bits/cxxabi_tweaks.h bits/cxxabi_forced.h"
- for i in ${libsupcxx_includes} ; do
- local found=""
- [ -d "${S}/include/$(dirname ${i})/" ] || mkdir -p "${S}/include/$(dirname ${i})"
- for j in ${libcxx_gcc_dirs} ; do
- if [ -f "${j}/${i}" ] ; then
- cp "${j}/${i}" "${S}/include/$(dirname ${i})/" || die
- found=yes
- fi
- done
- [ -n "${found}" ] || die "Header not found: ${i}"
- done
- fi
-
- append-ldflags "-Wl,-z,defs" # make sure we are not underlinked
-}
-
-multilib_src_compile() {
- cd "${BUILD_DIR}/lib" || die
- if [[ ${CHOST} == *darwin* ]] ; then
- TRIPLE=-apple- ./buildit || die
- return
- fi
-
- emake shared
- use static-libs && emake static
-}
-
-# Tests fail for now, if anybody is able to fix them, help is very welcome.
-multilib_src_test() {
- cd "${BUILD_DIR}/test"
- LD_LIBRARY_PATH="${BUILD_DIR}/lib:${LD_LIBRARY_PATH}" \
- CC="clang++ $(get_abi_CFLAGS) ${CXXFLAGS}" \
- HEADER_INCLUDE="-I${BUILD_DIR}/include" \
- SOURCE_LIB="-L${BUILD_DIR}/lib" \
- LIBS="-lm $(usex libcxxrt -lcxxrt "")" \
- ./testit || die
- # TODO: fix link against libsupc++
-}
-
-# Usage: deps
-gen_ldscript() {
- local output_format
- output_format=$($(tc-getCC) ${CFLAGS} ${LDFLAGS} -Wl,--verbose 2>&1 | sed -n 's/^OUTPUT_FORMAT("\([^"]*\)",.*/\1/p')
- [[ -n ${output_format} ]] && output_format="OUTPUT_FORMAT ( ${output_format} )"
-
- cat <<-END_LDSCRIPT
-/* GNU ld script
- Include missing dependencies
-*/
-${output_format}
-GROUP ( $@ )
-END_LDSCRIPT
-}
-
-gen_static_ldscript() {
- if use libcxxrt ; then
- # Move it first.
- mv "${ED}/usr/$(get_libdir)/libc++.a" "${ED}/usr/$(get_libdir)/libc++_static.a" || die
-
- # Generate libc++.a ldscript for inclusion of its dependencies so that
- # clang++ -stdlib=libc++ -static works out of the box.
- local deps="${EPREFIX}/usr/$(get_libdir)/libc++_static.a ${EPREFIX}/usr/$(get_libdir)/libcxxrt.a"
- # On Linux/glibc it does not link without libpthread or libdl. It is
- # fine on FreeBSD.
- use elibc_glibc && deps="${deps} ${EPREFIX}/usr/$(get_libdir)/libpthread.a ${EPREFIX}/usr/$(get_libdir)/libdl.a"
-
- gen_ldscript "${deps}" > "${ED}/usr/$(get_libdir)/libc++.a"
- fi
- # TODO: Generate a libc++.a ldscript when building against libsupc++
-}
-
-gen_shared_ldscript() {
- if use libcxxrt ; then
- mv "${ED}/usr/$(get_libdir)/libc++.so" "${ED}/usr/$(get_libdir)/libc++_shared.so" || die
- local deps="${EPREFIX}/usr/$(get_libdir)/libc++_shared.so ${EPREFIX}/usr/$(get_libdir)/libcxxrt.so"
- gen_ldscript "${deps}" > "${ED}/usr/$(get_libdir)/libc++.so"
- fi
- # TODO: Generate the linker script for other confiurations too.
-}
-
-multilib_src_install() {
- cd "${BUILD_DIR}/lib"
- if [[ ${CHOST} == *darwin* ]] ; then
- dolib.so libc++*dylib
- return
- fi
-
- if use static-libs ; then
- dolib.a libc++.a
- gen_static_ldscript
- fi
- dolib.so libc++.so*
- gen_shared_ldscript
-}
-
-multilib_src_install_all() {
- einstalldocs
- # libc++abi needs the libc++ headers and we need libc++abi so the headers
- # are already installed
- [[ ${CHOST} == *darwin* ]] && return
- insinto /usr/include/c++/v1
- doins -r include/*
-}
-
-pkg_postinst() {
- elog "This package (${PN}) is mainly intended as a replacement for the C++"
- elog "standard library when using clang."
- elog "To use it, instead of libstdc++, use:"
- elog " clang++ -stdlib=libc++"
- elog "to compile your C++ programs."
-}
^ permalink raw reply related [flat|nested] 12+ messages in thread
* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2016-09-07 7:35 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2016-09-07 7:35 UTC (permalink / raw
To: gentoo-commits
commit: edbcba87f78cc4b316e7fa1a3db36fb34bd11486
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Wed Sep 7 07:33:59 2016 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Wed Sep 7 07:35:43 2016 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=edbcba87
sys-libs/libcxx: sync to 3.8.1 version
Package-Manager: portage-2.2.28-prefix
sys-libs/libcxx/Manifest | 1 +
sys-libs/libcxx/libcxx-3.8.1.ebuild | 240 ++++++++++++++++++++++++++++++++++++
sys-libs/libcxx/metadata.xml | 5 +-
3 files changed, 245 insertions(+), 1 deletion(-)
diff --git a/sys-libs/libcxx/Manifest b/sys-libs/libcxx/Manifest
index 11bf65d..507db25 100644
--- a/sys-libs/libcxx/Manifest
+++ b/sys-libs/libcxx/Manifest
@@ -1,2 +1,3 @@
DIST libcxx-3.5.1.src.tar.xz 912248 SHA256 a16d0ae0c0cf2c8cebb94fafcb907022cd4f8579ebac99a4c9919990a37ad475 SHA512 3be33787c79aa5d03a3f507be20ef986215d6008e4f0370e3c5906d76a620bf27c9ed4c35f4561c1ac507a1b217fa7fc7577611e7205f3f2433c677bf86b8632 WHIRLPOOL 725892f113a918168b8ae8b5e93401130ccb1080c207445ba943c4fc06e481002939d37cfbbb59dc2791f91ccd7c673274ee523ec96418ed04ca22c8d11e2bec
DIST libcxx-3.7.1.src.tar.xz 995724 SHA256 357fbd4288ce99733ba06ae2bec6f503413d258aeebaab8b6a791201e6f7f144 SHA512 08d2399a8b36aa15290733256c896c9fa43f1a1223bc5c73bbcd014fddf8880e514d2a6dcc456bcf18b537c01fb6911b092e6d9958bccd8e64e9f375ed7a1ab9 WHIRLPOOL 19f77946abf48cbdd3e7ea21fd009ca3cc5f607dfe0512a44b102847044bb1d5ae4b16f503f18b14ebd9ea115256e87af07409907ba2a65f6061e217a502a359
+DIST libcxx-3.8.1.src.tar.xz 1074164 SHA256 77d7f3784c88096d785bd705fa1bab7031ce184cd91ba8a7008abf55264eeecc SHA512 782ff3cdb85d02e92404e943474d0266ff601725c202f0667d60e7807f1ba3cfdebbdb062e27a52fec96be1c99339044be93a88ba7e396682f98d99c9ac175b2 WHIRLPOOL a729c44060972edee79b0019fd4c6c23fa56dd625e564f4c5965682d9fc79be4094df0643f67c5d2ffa3ae3c743c892c3c9ba19719b2307aada35775f64ed104
diff --git a/sys-libs/libcxx/libcxx-3.8.1.ebuild b/sys-libs/libcxx/libcxx-3.8.1.ebuild
new file mode 100644
index 0000000..10fac31
--- /dev/null
+++ b/sys-libs/libcxx/libcxx-3.8.1.ebuild
@@ -0,0 +1,240 @@
+# Copyright 1999-2016 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id $
+
+EAPI=5
+
+ESVN_REPO_URI="http://llvm.org/svn/llvm-project/libcxx/trunk"
+
+[ "${PV%9999}" != "${PV}" ] && SCM="subversion" || SCM=""
+
+inherit ${SCM} flag-o-matic toolchain-funcs multilib multilib-minimal
+
+DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
+HOMEPAGE="http://libcxx.llvm.org/"
+if [ "${PV%9999}" = "${PV}" ] ; then
+ SRC_URI="http://llvm.org/releases/${PV}/${P}.src.tar.xz"
+ S="${WORKDIR}/${P}.src"
+else
+ SRC_URI=""
+fi
+
+LICENSE="|| ( UoI-NCSA MIT )"
+SLOT="0"
+if [ "${PV%9999}" = "${PV}" ] ; then
+ KEYWORDS="~x64-macos ~x86-macos"
+else
+ KEYWORDS=""
+fi
+IUSE="elibc_glibc +libcxxrt static-libs test"
+
+REQUIRED_USE="kernel_Darwin? ( libcxxrt !static-libs )"
+RDEPEND="
+ !kernel_Darwin? (
+ libcxxrt? ( >=sys-libs/libcxxrt-0.0_p20130725[static-libs?,${MULTILIB_USEDEP}] )
+ !libcxxrt? ( >=sys-devel/gcc-4.7[cxx] )
+ )
+ kernel_Darwin? (
+ =sys-libs/libcxx-headers-${PV}
+ =sys-libs/libcxxabi-${PV}
+ sys-devel/clang
+ )"
+DEPEND="${RDEPEND}
+ test? ( sys-devel/clang )
+ app-arch/xz-utils"
+
+DOCS=( CREDITS.TXT )
+
+pkg_setup() {
+ if [[ ${CHOST} == *darwin* ]] ; then
+ MY_CC=$(tc-getCC)
+ MY_CXX=$(tc-getCXX)
+ if [[ ${MY_CC} != *clang* || ${MY_CXX} != *clang++* ]] ; then
+ eerror "${PN} needs to be built with clang++. Please do not override"
+ eerror "CC ($MY_CC) and CXX ($MY_CXX)"
+ eerror "or point them at clang and clang++ respectively."
+ die
+ fi
+ return
+ fi
+ if ! use libcxxrt ; then
+ ewarn "You have disabled USE=libcxxrt. This will build ${PN} against"
+ ewarn "libsupc++. Please note that this is not well supported."
+ ewarn "In particular, static linking will not work."
+ fi
+ if [[ $(gcc-version) < 4.7 ]] && [[ $(tc-getCXX) != *clang++* ]] ; then
+ eerror "${PN} needs to be built with clang++ or gcc-4.7 or later."
+ eerror "Please use gcc-config to switch to gcc-4.7 or later version."
+ die
+ fi
+}
+
+src_prepare() {
+ cp -f "${FILESDIR}/Makefile" lib/ || die
+
+ if [[ ${CHOST} == *darwin* ]] ; then
+ epatch "${FILESDIR}"/${PN}-3.5.1-olddarwin.patch
+
+ [[ "${CHOST##*-darwin}" -le 10 ]] && \
+ epatch "${FILESDIR}"/${PN}-3.5.1-cmath-conv.patch
+
+ # libc++abi needs stack unwinding functions provided by libSystem on
+ # Mac OS X >= 10.6. On < 10.6 they're in libgcc_s. So force link
+ # against that. Additionally, the crt1.o provided by our gcc-apple
+ # toolchain isn't universal. Since that's needed for linking any
+ # program on OS X < 10.7, universal support is effectively broken on
+ # those older OS Xes even if clang and libc++{,abi} were to support it.
+ # So we can just disable universal compilation.
+ gcc_s=gcc_s.1
+ [[ "${CHOST##*-darwin}" -eq 9 ]] && gcc_s=gcc_s.10.5
+ [[ "${CHOST##*-darwin}" -eq 8 ]] && gcc_s=gcc_s.10.4
+ [[ "${CHOST##*-darwin}" -le 9 ]] && \
+ sed -i -e "s,/usr/lib/libSystem.B.dylib,-lSystem -l${gcc_s},g" \
+ -e "s,-arch i386 -arch x86_64,,g" \
+ lib/buildit
+
+ if [[ "${CHOST##*-darwin}" -le 8 ]] ; then
+ epatch "${FILESDIR}"/${PN}-3.5.1-availability.patch
+ epatch "${FILESDIR}"/${PN}-3.5.1-eprintf.patch
+ fi
+
+ # fix library install names
+ sed -i \
+ -e "s,/usr/lib/libc++abi\.dylib,${EPREFIX}/usr/lib/libc++abi.dylib,g" \
+ -e "s,/usr/lib/libc++\.1\.dylib,${EPREFIX}/usr/lib/libc++.1.dylib,g" \
+ lib/buildit
+ fi
+
+ multilib_copy_sources
+}
+
+src_configure() {
+ tc-export AR CC CXX
+
+ # on Darwin we're all set
+ [[ ${CHOST} == *darwin* ]] && return
+
+ export LIBS="-lpthread -lrt -lc -lgcc_s"
+ if use libcxxrt ; then
+ append-cppflags -DLIBCXXRT "-I${EPREFIX}/usr/include/libcxxrt/"
+ LIBS="-lcxxrt ${LIBS}"
+ cp "${EPREFIX}/usr/include/libcxxrt/"*.h "${S}/include"
+ else
+ # Very hackish, see $HOMEPAGE
+ # If someone has a clever idea, please share it!
+ local includes="$(echo | ${CHOST}-g++ -Wp,-v -x c++ - -fsyntax-only 2>&1 | grep -C 2 '#include.*<...>' | tail -n 2 | sed -e 's/^ /-I/' | tr '\n' ' ')"
+ local libcxx_gcc_dirs="$(echo | ${CHOST}-g++ -Wp,-v -x c++ - -fsyntax-only 2>&1 | grep -C 2 '#include.*<...>' | tail -n 2 | tr '\n' ' ')"
+ append-cppflags -D__GLIBCXX__ ${includes}
+ LIBS="-lsupc++ ${LIBS}"
+ local libsupcxx_includes="cxxabi.h bits/c++config.h bits/os_defines.h bits/cpu_defines.h bits/cxxabi_tweaks.h bits/cxxabi_forced.h"
+ for i in ${libsupcxx_includes} ; do
+ local found=""
+ [ -d "${S}/include/$(dirname ${i})/" ] || mkdir -p "${S}/include/$(dirname ${i})"
+ for j in ${libcxx_gcc_dirs} ; do
+ if [ -f "${j}/${i}" ] ; then
+ cp "${j}/${i}" "${S}/include/$(dirname ${i})/" || die
+ found=yes
+ fi
+ done
+ [ -n "${found}" ] || die "Header not found: ${i}"
+ done
+ fi
+
+ append-ldflags "-Wl,-z,defs" # make sure we are not underlinked
+}
+
+multilib_src_compile() {
+ cd "${BUILD_DIR}/lib" || die
+ if [[ ${CHOST} == *darwin* ]] ; then
+ TRIPLE=-apple- ./buildit || die
+ return
+ fi
+
+ emake shared
+ use static-libs && emake static
+}
+
+# Tests fail for now, if anybody is able to fix them, help is very welcome.
+multilib_src_test() {
+ cd "${BUILD_DIR}/test"
+ LD_LIBRARY_PATH="${BUILD_DIR}/lib:${LD_LIBRARY_PATH}" \
+ CC="clang++ $(get_abi_CFLAGS) ${CXXFLAGS}" \
+ HEADER_INCLUDE="-I${BUILD_DIR}/include" \
+ SOURCE_LIB="-L${BUILD_DIR}/lib" \
+ LIBS="-lm $(usex libcxxrt -lcxxrt "")" \
+ ./testit || die
+ # TODO: fix link against libsupc++
+}
+
+# Usage: deps
+gen_ldscript() {
+ local output_format
+ output_format=$($(tc-getCC) ${CFLAGS} ${LDFLAGS} -Wl,--verbose 2>&1 | sed -n 's/^OUTPUT_FORMAT("\([^"]*\)",.*/\1/p')
+ [[ -n ${output_format} ]] && output_format="OUTPUT_FORMAT ( ${output_format} )"
+
+ cat <<-END_LDSCRIPT
+/* GNU ld script
+ Include missing dependencies
+*/
+${output_format}
+GROUP ( $@ )
+END_LDSCRIPT
+}
+
+gen_static_ldscript() {
+ if use libcxxrt ; then
+ # Move it first.
+ mv "${ED}/usr/$(get_libdir)/libc++.a" "${ED}/usr/$(get_libdir)/libc++_static.a" || die
+
+ # Generate libc++.a ldscript for inclusion of its dependencies so that
+ # clang++ -stdlib=libc++ -static works out of the box.
+ local deps="${EPREFIX}/usr/$(get_libdir)/libc++_static.a ${EPREFIX}/usr/$(get_libdir)/libcxxrt.a"
+ # On Linux/glibc it does not link without libpthread or libdl. It is
+ # fine on FreeBSD.
+ use elibc_glibc && deps="${deps} ${EPREFIX}/usr/$(get_libdir)/libpthread.a ${EPREFIX}/usr/$(get_libdir)/libdl.a"
+
+ gen_ldscript "${deps}" > "${ED}/usr/$(get_libdir)/libc++.a"
+ fi
+ # TODO: Generate a libc++.a ldscript when building against libsupc++
+}
+
+gen_shared_ldscript() {
+ if use libcxxrt ; then
+ mv "${ED}/usr/$(get_libdir)/libc++.so" "${ED}/usr/$(get_libdir)/libc++_shared.so" || die
+ local deps="${EPREFIX}/usr/$(get_libdir)/libc++_shared.so ${EPREFIX}/usr/$(get_libdir)/libcxxrt.so"
+ gen_ldscript "${deps}" > "${ED}/usr/$(get_libdir)/libc++.so"
+ fi
+ # TODO: Generate the linker script for other confiurations too.
+}
+
+multilib_src_install() {
+ cd "${BUILD_DIR}/lib"
+ if [[ ${CHOST} == *darwin* ]] ; then
+ dolib.so libc++*dylib
+ return
+ fi
+
+ if use static-libs ; then
+ dolib.a libc++.a
+ gen_static_ldscript
+ fi
+ dolib.so libc++.so*
+ gen_shared_ldscript
+}
+
+multilib_src_install_all() {
+ einstalldocs
+ # libc++abi needs the libc++ headers and we need libc++abi so the headers
+ # are already installed
+ [[ ${CHOST} == *darwin* ]] && return
+ insinto /usr/include/c++/v1
+ doins -r include/*
+}
+
+pkg_postinst() {
+ elog "This package (${PN}) is mainly intended as a replacement for the C++"
+ elog "standard library when using clang."
+ elog "To use it, instead of libstdc++, use:"
+ elog " clang++ -stdlib=libc++"
+ elog "to compile your C++ programs."
+}
diff --git a/sys-libs/libcxx/metadata.xml b/sys-libs/libcxx/metadata.xml
index 6795d17..4269b68 100644
--- a/sys-libs/libcxx/metadata.xml
+++ b/sys-libs/libcxx/metadata.xml
@@ -1,7 +1,10 @@
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
<pkgmetadata>
- <herd>prefix</herd>
+ <maintainer type="project">
+ <email>prefix@gentoo.org</email>
+ <name>Prefix Project</name>
+ </maintainer>
<use>
<flag name="libcxxrt">Build against <pkg>sys-libs/libcxxr</pkg></flag>
</use>
^ permalink raw reply related [flat|nested] 12+ messages in thread
* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2018-01-02 16:21 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2018-01-02 16:21 UTC (permalink / raw
To: gentoo-commits
commit: dfb79c4a7df3b2a3c2f47f46b241e8213c174c2e
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Tue Jan 2 16:21:33 2018 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Tue Jan 2 16:21:33 2018 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=dfb79c4a
sys-libs/libcxx: fix path references by Michael Weiser, bug #538364
Closes: https://bugs.gentoo.org/538364
Package-Manager: Portage-2.3.18-prefix, Repoman-2.3.6
sys-libs/libcxx/libcxx-5.0.1.ebuild | 9 +++++++++
1 file changed, 9 insertions(+)
diff --git a/sys-libs/libcxx/libcxx-5.0.1.ebuild b/sys-libs/libcxx/libcxx-5.0.1.ebuild
index 889825b71c..2aaca9ae4f 100644
--- a/sys-libs/libcxx/libcxx-5.0.1.ebuild
+++ b/sys-libs/libcxx/libcxx-5.0.1.ebuild
@@ -61,6 +61,15 @@ PATCHES=(
"${FILESDIR}/${PN}-3.9-cmake-link-flags.patch"
)
+src_prepare() {
+ default
+
+ # eprefixify static path references to libc++abi for symbol re-export to
+ # avoid linking against it twice in both /usr/lib and ${EPREFIX}/usr/lib
+ local lcpa=/usr/lib/libc++abi.dylib
+ sed -i -e "s,${lcpa},${EPREFIX}${lcpa},g" lib/CMakeLists.txt
+}
+
python_check_deps() {
has_version "dev-python/lit[${PYTHON_USEDEP}]"
}
^ permalink raw reply related [flat|nested] 12+ messages in thread
* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2018-01-02 16:21 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2018-01-02 16:21 UTC (permalink / raw
To: gentoo-commits
commit: ce4edc8cdd9d6a2ec822de9ce37febb8b05402ff
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Tue Jan 2 16:18:01 2018 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Tue Jan 2 16:18:01 2018 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=ce4edc8c
sys-libs/libcxx: bump to 5.0.1 by Michael Weiser, bug #538364
Bug: https://bugs.gentoo.org/538364
Package-Manager: Portage-2.3.18-prefix, Repoman-2.3.6
sys-libs/libcxx/Manifest | 2 +-
sys-libs/libcxx/libcxx-3.9.0.ebuild | 157 ------------------------
sys-libs/libcxx/libcxx-5.0.1.ebuild | 230 ++++++++++++++++++++++++++++++++++++
3 files changed, 231 insertions(+), 158 deletions(-)
diff --git a/sys-libs/libcxx/Manifest b/sys-libs/libcxx/Manifest
index d58be2fa2e..b998ef46cd 100644
--- a/sys-libs/libcxx/Manifest
+++ b/sys-libs/libcxx/Manifest
@@ -1,5 +1,5 @@
DIST libcxx-3.5.1.src.tar.xz 912248 BLAKE2B 9215341a119eb56be7f6cefe9b8de664ab2e9e5e208ab017aa73cd539c8f5f9e0b41209f245904793adf2933a72afd0aa2428fb1983480190d4e2f4e83e62e0d SHA512 3be33787c79aa5d03a3f507be20ef986215d6008e4f0370e3c5906d76a620bf27c9ed4c35f4561c1ac507a1b217fa7fc7577611e7205f3f2433c677bf86b8632
DIST libcxx-3.7.1.src.tar.xz 995724 BLAKE2B aab68f1b99a2c817e7154b71c04c81bd809154d1ae1c077a2dfede37319070729d6d768223b6ba5e2a866d6c2f18972dd501ce517864378ebc26c49cacafb635 SHA512 08d2399a8b36aa15290733256c896c9fa43f1a1223bc5c73bbcd014fddf8880e514d2a6dcc456bcf18b537c01fb6911b092e6d9958bccd8e64e9f375ed7a1ab9
DIST libcxx-3.8.1.src.tar.xz 1074164 BLAKE2B 8aa07974a0301684f852408a62c173084fb913179bec951df3bae33895f8b46434eddc95b838cb936a5ef31f5b8ead25b7d0e241adc039eaea38ef95045c8ccb SHA512 782ff3cdb85d02e92404e943474d0266ff601725c202f0667d60e7807f1ba3cfdebbdb062e27a52fec96be1c99339044be93a88ba7e396682f98d99c9ac175b2
-DIST libcxx-3.9.0.src.tar.xz 1198308 BLAKE2B 689fed969562466bd230445a0edb886880d1034c45d5387922d1dd307898547e5605035c5aa901f3e844be3c1b2d066cf27aa0b996d7ade176ee38a9f49ac98a SHA512 55d5c4adff378ee02b0b99d732bc9f326910f9e49ab8c320a588eccdd0362fe009bc9a6a4337d29faf6338420c91b10d0d7d67f66128268f01258d30502c4f4a
DIST libcxx-3.9.1.src.tar.xz 1209020 BLAKE2B 510e77c2c1163babbba904933f441e8720b0d366b9f0cfa2cdde2401368c224e00efd66afc1403b0087c40549cda4ebbc4d0c4b2d0906178324fa6158502d5ad SHA512 a5976e4096624a7307b3e43f4a22ac2dc74572226e0f57af9f3ef537a14c3cff1601b7042aef9dc40a0ee53ca76b08d72eb9c253dcf34f115d3153c302db7070
+DIST libcxx-5.0.1.src.tar.xz 1527852 BLAKE2B 9454fbca8228ee456feb79b65a63ce5daa27bf2e47e457d79592f4974dceeace19fe6cdeee51cc51f94e9072d7ce3c03e5acb617507670153647b9c435feadbd SHA512 994681d3c79047fc2d618c5584b08e9b5c925dab48f8812fc0adc81a575b49a637e9481bb9a0f7ae6f7f352b2b33f40056c347c27123cd6c96c6c226febd002c
diff --git a/sys-libs/libcxx/libcxx-3.9.0.ebuild b/sys-libs/libcxx/libcxx-3.9.0.ebuild
deleted file mode 100644
index 4d5e1ee549..0000000000
--- a/sys-libs/libcxx/libcxx-3.9.0.ebuild
+++ /dev/null
@@ -1,157 +0,0 @@
-# Copyright 1999-2016 Gentoo Foundation
-# Distributed under the terms of the GNU General Public License v2
-# $Id $
-
-EAPI=5
-
-ESVN_REPO_URI="http://llvm.org/svn/llvm-project/libcxx/trunk"
-
-[ "${PV%9999}" != "${PV}" ] && SCM="subversion" || SCM=""
-
-inherit ${SCM} flag-o-matic toolchain-funcs cmake-multilib
-
-DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
-HOMEPAGE="http://libcxx.llvm.org/"
-if [ "${PV%9999}" = "${PV}" ] ; then
- SRC_URI="http://llvm.org/releases/${PV}/${P}.src.tar.xz"
- S="${WORKDIR}/${P}.src"
-else
- SRC_URI=""
-fi
-
-LICENSE="|| ( UoI-NCSA MIT )"
-SLOT="0"
-if [ "${PV%9999}" = "${PV}" ] ; then
- KEYWORDS="~x64-macos ~x86-macos"
-else
- KEYWORDS=""
-fi
-REQUIRED_USE="kernel_Darwin? ( libcxxabi !static-abi-lib )"
-IUSE="elibc_glibc libcxxrt +libcxxabi static-libs static-abi-lib test"
-
-RDEPEND="
- !kernel_Darwin? (
- libcxxrt? ( >=sys-libs/libcxxrt-0.0_p20130725[static-libs?,${MULTILIB_USEDEP}] )
- !libcxxrt? ( >=sys-devel/gcc-4.7[cxx] )
- )
- kernel_Darwin? (
- =sys-libs/libcxx-headers-${PV}
- =sys-libs/libcxxabi-${PV}
- sys-devel/clang
- )"
-DEPEND="${RDEPEND}
- test? ( sys-devel/clang )
- app-arch/xz-utils
- static-abi-lib? (
- libcxxabi? ( sys-libs/libcxxabi[static-libs] )
- !libcxxabi? (
- libcxxrt? ( sys-libs/libcxxrt[static-libs] )
- )
- )
- "
-
-DOCS=( CREDITS.TXT )
-
-pkg_setup() {
- if [[ ${CHOST} == *darwin* ]] ; then
- MY_CC=$(tc-getCC)
- MY_CXX=$(tc-getCXX)
- if [[ ${MY_CC} != *clang* || ${MY_CXX} != *clang++* ]] ; then
- eerror "${PN} needs to be built with clang++. Please do not override"
- eerror "CC ($MY_CC) and CXX ($MY_CXX)"
- eerror "or point them at clang and clang++ respectively."
- die
- fi
- fi
- if ! use libcxxabi && ! use libcxxrt ; then
- ewarn "You have disabled USE=libcxxrt. This will build ${PN} against"
- ewarn "libsupc++. Please note that this is not well supported."
- ewarn "In particular, static linking will not work."
- fi
- if [[ $(gcc-version) < 4.7 ]] && [[ $(tc-getCXX) != *clang++* ]] ; then
- eerror "${PN} needs to be built with clang++ or gcc-4.7 or later."
- eerror "Please use gcc-config to switch to gcc-4.7 or later version."
- die
- fi
-}
-
-src_prepare() {
- sed -i -e "/set.LLVM_CMAKE_PATH.*\\/cmake\\/modules/s@cmake/modules@cmake@" cmake/Modules/HandleOutOfTreeLLVM.cmake
-
- # The library can only be built as either shared or static. So use two
- # separate build dirs with separate configurations.
- BUILD_DIR_SHARED=${WORKDIR}/${P}_build
- BUILD_DIR_STATIC=${WORKDIR}/${P}_build_static
-}
-
-src_configure() {
- local mycmakeargs=(
- -DLLVM_PATH=${EPREFIX}/usr/share/llvm
- -DLIBCXX_INSTALL_HEADERS=NO
- )
-
- # make sure we build multilib on OSX, because llvm insists on
- # building multilib too
- [[ ${CHOST} == *86*-darwin* ]] && append-flags -arch i386 -arch x86_64
-
- if use libcxxabi ; then
- mycmakeargs+=(
- -DLIBCXX_CXX_ABI=libcxxabi
- # avoid guessing of libcxxabi version by installed SDK discovered
- # via xc-run - we know better because we require a libcxxabi version
- # matching our own
- -DLIBCXX_LIBCPPABI_VERSION=2
- # avoid configure warning about not being able to find cxxabi.h
- -DLIBCXX_CXX_ABI_INCLUDE_PATHS=${EPREFIX}/usr/include
- )
- elif use libcxxrt ; then
- mycmakeargs+=( -DLIBCXX_CXX_ABI=libcxxrt )
- else
- mycmakeargs+=( -DLIBCXX_CXX_ABI=libsupc++ )
- fi
-
- use static-abi-lib && mycmakeargs+=( -DLIBCXX_ENABLE_STATIC_ABI_LIBRARY=ON )
- use test && mycmakeargs+=( -DLIBCXX_INCLUDE_TESTS=ON )
-
- BUILD_DIR=${BUILD_DIR_SHARED} cmake-multilib_src_configure
- if use static-libs ; then
- mycmakeargs+=( -DLIBCXX_ENABLE_SHARED=NO )
- BUILD_DIR=${BUILD_DIR_STATIC} cmake-multilib_src_configure
- fi
-}
-
-src_compile() {
- BUILD_DIR=${BUILD_DIR_SHARED} cmake-multilib_src_compile
-
- # reconfigure and recompile for additional static libs if enabled
- use static-libs && \
- BUILD_DIR=${BUILD_DIR_STATIC} cmake-multilib_src_compile
-}
-
-src_test() {
- BUILD_DIR=${BUILD_DIR_SHARED} cmake-multilib_src_test
- use static-libs && \
- BUILD_DIR=${BUILD_DIR_STATIC} cmake-multilib_src_test
-}
-
-multilib_src_test() {
- cmake-utils_src_make check-libcxx
-}
-
-src_install() {
- BUILD_DIR=${BUILD_DIR_SHARED} cmake-multilib_src_install
- use static-libs && \
- BUILD_DIR=${BUILD_DIR_STATIC} cmake-multilib_src_install
-}
-
-multilib_src_install_all() {
- einstalldocs
-}
-
-pkg_postinst() {
- elog "This package (${PN}) is mainly intended as a replacement for the C++"
- elog "standard library when using clang."
- elog "To use it, instead of libstdc++, use:"
- elog " clang++ -stdlib=libc++"
- elog "to compile your C++ programs."
-}
diff --git a/sys-libs/libcxx/libcxx-5.0.1.ebuild b/sys-libs/libcxx/libcxx-5.0.1.ebuild
new file mode 100644
index 0000000000..889825b71c
--- /dev/null
+++ b/sys-libs/libcxx/libcxx-5.0.1.ebuild
@@ -0,0 +1,230 @@
+# Copyright 1999-2018 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=6
+
+# Ninja provides better scalability and cleaner verbose output, and is used
+# throughout all LLVM projects.
+: ${CMAKE_MAKEFILE_GENERATOR:=ninja}
+EGIT_REPO_URI="http://llvm.org/git/libcxx.git
+ https://github.com/llvm-mirror/libcxx.git"
+PYTHON_COMPAT=( python2_7 )
+
+[[ ${PV} == 9999 ]] && SCM="git-r3" || SCM=""
+
+inherit ${SCM} cmake-multilib python-any-r1 toolchain-funcs flag-o-matic
+
+DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
+HOMEPAGE="http://libcxx.llvm.org/"
+if [[ ${PV} != 9999 ]] ; then
+ SRC_URI="http://llvm.org/releases/${PV}/${P}.src.tar.xz"
+ S="${WORKDIR}/${P}.src"
+else
+ SRC_URI=""
+fi
+
+LICENSE="|| ( UoI-NCSA MIT )"
+SLOT="0"
+if [[ ${PV} != 9999 ]] ; then
+ KEYWORDS="~x64-macos ~x86-macos"
+else
+ KEYWORDS=""
+fi
+IUSE="elibc_Darwin elibc_glibc elibc_musl +libcxxabi libcxxrt libunwind +static-libs test"
+REQUIRED_USE="libunwind? ( || ( libcxxabi libcxxrt ) )
+ elibc_Darwin? ( libcxxabi )
+ ?? ( libcxxabi libcxxrt )"
+
+RDEPEND="
+ libcxxabi? ( ~sys-libs/libcxxabi-${PV}[libunwind=,static-libs?,${MULTILIB_USEDEP}] )
+ !elibc_Darwin? (
+ libcxxrt? ( sys-libs/libcxxrt[libunwind=,static-libs?,${MULTILIB_USEDEP}] )
+ !libcxxabi? ( !libcxxrt? ( >=sys-devel/gcc-4.7:=[cxx] ) )
+ )
+ elibc_Darwin? ( !sys-libs/libcxx-headers )"
+# llvm-3.9.0 needed because its cmake files installation path changed, which is
+# needed by libcxx
+# clang-3.9.0 installs necessary target symlinks unconditionally
+# which removes the need for MULTILIB_USEDEP
+DEPEND="${RDEPEND}
+ test? ( >=sys-devel/clang-3.9.0
+ $(python_gen_any_dep 'dev-python/lit[${PYTHON_USEDEP}]') )
+ app-arch/xz-utils
+ >=sys-devel/llvm-3.9.0"
+
+DOCS=( CREDITS.TXT )
+
+PATCHES=(
+ # Add link flag "-Wl,-z,defs" to avoid underlinking; this is needed in a
+ # out-of-tree build.
+ "${FILESDIR}/${PN}-3.9-cmake-link-flags.patch"
+)
+
+python_check_deps() {
+ has_version "dev-python/lit[${PYTHON_USEDEP}]"
+}
+
+pkg_setup() {
+ use test && python-any-r1_pkg_setup
+
+ if ! use libcxxabi && ! use libcxxrt && ! tc-is-gcc ; then
+ eerror "To build ${PN} against libsupc++, you have to use gcc. Other"
+ eerror "compilers are not supported. Please set CC=gcc and CXX=g++"
+ eerror "and try again."
+ die
+ fi
+ if tc-is-gcc && [[ $(gcc-version) < 4.7 ]] ; then
+ eerror "${PN} needs to be built with gcc-4.7 or later (or other"
+ eerror "conformant compilers). Please use gcc-config to switch to"
+ eerror "gcc-4.7 or later version."
+ die
+ fi
+}
+
+src_configure() {
+ NATIVE_LIBDIR=$(get_libdir)
+ cmake-multilib_src_configure
+}
+
+multilib_src_configure() {
+ local cxxabi cxxabi_incs
+ if use libcxxabi; then
+ cxxabi=libcxxabi
+ cxxabi_incs="${EPREFIX}/usr/include/libcxxabi"
+ elif use libcxxrt; then
+ cxxabi=libcxxrt
+ cxxabi_incs="${EPREFIX}/usr/include/libcxxrt"
+ else
+ local gcc_inc="${EPREFIX}/usr/lib/gcc/${CHOST}/$(gcc-fullversion)/include/g++-v$(gcc-major-version)"
+ cxxabi=libsupc++
+ cxxabi_incs="${gcc_inc};${gcc_inc}/${CHOST}"
+ fi
+
+ # we want -lgcc_s for unwinder, and for compiler runtime when using
+ # gcc, clang with gcc runtime (or any unknown compiler)
+ local extra_libs=() want_gcc_s=ON
+ if use libunwind; then
+ # work-around missing -lunwind upstream
+ extra_libs+=( -lunwind )
+ # if we're using libunwind and clang with compiler-rt, we want
+ # to link to compiler-rt instead of -lgcc_s
+ if tc-is-clang; then
+ # get the full library list out of 'pretend mode'
+ # and grep it for libclang_rt references
+ local args=( $($(tc-getCC) -### -x c - 2>&1 | tail -n 1) )
+ local i
+ for i in "${args[@]}"; do
+ if [[ ${i} == *libclang_rt* ]]; then
+ want_gcc_s=OFF
+ extra_libs+=( "${i}" )
+ fi
+ done
+ fi
+ fi
+ # Darwin has libunwind in its system
+ [[ ${CHOST} == *-darwin* ]] && want_gcc_s=OFF
+
+ local libdir=$(get_libdir)
+ local mycmakeargs=(
+ # LLVM_LIBDIR_SUFFIX is used to find CMake files
+ # and we are happy to use the native set
+ -DLLVM_LIBDIR_SUFFIX=${NATIVE_LIBDIR#lib}
+ -DLIBCXX_LIBDIR_SUFFIX=${libdir#lib}
+ -DLIBCXX_ENABLE_SHARED=ON
+ -DLIBCXX_ENABLE_STATIC=$(usex static-libs)
+ -DLIBCXX_CXX_ABI=${cxxabi}
+ -DLIBCXX_CXX_ABI_INCLUDE_PATHS=${cxxabi_incs}
+ # we're using our own mechanism for generating linker scripts
+ -DLIBCXX_ENABLE_ABI_LINKER_SCRIPT=OFF
+ -DLIBCXX_HAS_MUSL_LIBC=$(usex elibc_musl)
+ -DLIBCXX_HAS_GCC_S_LIB=${want_gcc_s}
+ -DLIBCXX_INCLUDE_TESTS=$(usex test)
+ -DCMAKE_SHARED_LINKER_FLAGS="${extra_libs[*]} ${LDFLAGS}"
+ # avoid guessing of libcxxabi version by installed SDK discovered
+ # via xc-run - we know better because we require a libcxxabi version
+ # matching our own
+ -DLIBCXX_LIBCPPABI_VERSION=2
+ )
+
+ if use test; then
+ mycmakeargs+=(
+ # this can be any directory, it just needs to exist...
+ -DLLVM_MAIN_SRC_DIR="${T}"
+ -DLIT_COMMAND="${EPREFIX}"/usr/bin/lit
+ )
+ fi
+
+ # make sure we build multilib on OSX, because llvm insists on
+ # building multilib too
+ [[ ${CHOST} == *86*-darwin* ]] && append-flags -arch i386 -arch x86_64
+
+ cmake-utils_src_configure
+}
+
+multilib_src_test() {
+ local clang_path=$(type -P "${CHOST:+${CHOST}-}clang" 2>/dev/null)
+
+ [[ -n ${clang_path} ]] || die "Unable to find ${CHOST}-clang for tests"
+ sed -i -e "/cxx_under_test/s^\".*\"^\"${clang_path}\"^" test/lit.site.cfg || die
+
+ cmake-utils_src_make check-libcxx
+}
+
+# Usage: deps
+gen_ldscript() {
+ local output_format
+ output_format=$($(tc-getCC) ${CFLAGS} ${LDFLAGS} -Wl,--verbose 2>&1 | sed -n 's/^OUTPUT_FORMAT("\([^"]*\)",.*/\1/p')
+ [[ -n ${output_format} ]] && output_format="OUTPUT_FORMAT ( ${output_format} )"
+
+ cat <<-END_LDSCRIPT
+/* GNU ld script
+ Include missing dependencies
+*/
+${output_format}
+GROUP ( $@ )
+END_LDSCRIPT
+}
+
+gen_static_ldscript() {
+ local libdir=$(get_libdir)
+ local cxxabi_lib=$(usex libcxxabi "libc++abi.a" "$(usex libcxxrt "libcxxrt.a" "libsupc++.a")")
+
+ # Move it first.
+ mv "${ED}/usr/${libdir}/libc++.a" "${ED}/usr/${libdir}/libc++_static.a" || die
+ # Generate libc++.a ldscript for inclusion of its dependencies so that
+ # clang++ -stdlib=libc++ -static works out of the box.
+ local deps="libc++_static.a ${cxxabi_lib} $(usex libunwind libunwind.a libgcc_eh.a)"
+ # On Linux/glibc it does not link without libpthread or libdl. It is
+ # fine on FreeBSD.
+ use elibc_glibc && deps+=" libpthread.a libdl.a"
+
+ gen_ldscript "${deps}" > "${ED}/usr/${libdir}/libc++.a" || die
+}
+
+gen_shared_ldscript() {
+ local libdir=$(get_libdir)
+ # libsupc++ doesn't have a shared version
+ local cxxabi_lib=$(usex libcxxabi "libc++abi.so" "$(usex libcxxrt "libcxxrt.so" "libsupc++.a")")
+
+ mv "${ED}/usr/${libdir}/libc++.so" "${ED}/usr/${libdir}/libc++_shared.so" || die
+ local deps="libc++_shared.so ${cxxabi_lib} $(usex libunwind libunwind.so libgcc_s.so)"
+
+ gen_ldscript "${deps}" > "${ED}/usr/${libdir}/libc++.so" || die
+}
+
+multilib_src_install() {
+ cmake-utils_src_install
+ if [[ ${CHOST} != *-darwin* ]] ; then
+ gen_shared_ldscript
+ use static-libs && gen_static_ldscript
+ fi
+}
+
+pkg_postinst() {
+ elog "This package (${PN}) is mainly intended as a replacement for the C++"
+ elog "standard library when using clang."
+ elog "To use it, instead of libstdc++, use:"
+ elog " clang++ -stdlib=libc++"
+ elog "to compile your C++ programs."
+}
^ permalink raw reply related [flat|nested] 12+ messages in thread
* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2018-01-08 19:59 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2018-01-08 19:59 UTC (permalink / raw
To: gentoo-commits
commit: a92c62593fcb6d0b62de8d1d615db1ecc6bb59da
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Mon Jan 8 19:59:49 2018 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Mon Jan 8 19:59:49 2018 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=a92c6259
sys-libs/libcxx: fix linking on ppc (need -fPIC explicitly)
Package-Manager: Portage-2.3.18-prefix, Repoman-2.3.6
sys-libs/libcxx/libcxx-3.5.1.ebuild | 6 +++++-
1 file changed, 5 insertions(+), 1 deletion(-)
diff --git a/sys-libs/libcxx/libcxx-3.5.1.ebuild b/sys-libs/libcxx/libcxx-3.5.1.ebuild
index 787a678359..66c8c8f018 100644
--- a/sys-libs/libcxx/libcxx-3.5.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.5.1.ebuild
@@ -1,4 +1,4 @@
-# Copyright 1999-2016 Gentoo Foundation
+# Copyright 1999-2018 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Id $
@@ -98,6 +98,10 @@ src_prepare() {
epatch "${FILESDIR}"/${PN}-3.5.1-eprintf.patch
fi
+ if [[ ${CHOST} == powerpc*-darwin* ]] ; then
+ sed -i -e '/RC_CFLAGS=""/s/""/"-fPIC"/' lib/buildit || die
+ fi
+
# fix library install names
sed -i \
-e "s,/usr/lib/libc++abi\.dylib,${EPREFIX}/usr/lib/libc++abi.dylib,g" \
^ permalink raw reply related [flat|nested] 12+ messages in thread
* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2018-01-09 7:55 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2018-01-09 7:55 UTC (permalink / raw
To: gentoo-commits
commit: 3b4cf474022f01850c98f7ec717440ff227ae976
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Tue Jan 9 07:54:06 2018 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Tue Jan 9 07:54:06 2018 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=3b4cf474
sys-libs/libcxx: remove vcs headers
Package-Manager: Portage-2.3.18-prefix, Repoman-2.3.6
sys-libs/libcxx/libcxx-3.5.1.ebuild | 1 -
sys-libs/libcxx/libcxx-3.7.1.ebuild | 3 +--
sys-libs/libcxx/libcxx-3.8.1.ebuild | 3 +--
sys-libs/libcxx/libcxx-3.9.1.ebuild | 3 +--
sys-libs/libcxx/libcxx-5.0.1.ebuild | 1 -
5 files changed, 3 insertions(+), 8 deletions(-)
diff --git a/sys-libs/libcxx/libcxx-3.5.1.ebuild b/sys-libs/libcxx/libcxx-3.5.1.ebuild
index 0de443a4e4..8a27c5d416 100644
--- a/sys-libs/libcxx/libcxx-3.5.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.5.1.ebuild
@@ -1,6 +1,5 @@
# Copyright 1999-2018 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-# $Id $
EAPI=5
diff --git a/sys-libs/libcxx/libcxx-3.7.1.ebuild b/sys-libs/libcxx/libcxx-3.7.1.ebuild
index 10fac31054..47ba26312d 100644
--- a/sys-libs/libcxx/libcxx-3.7.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.7.1.ebuild
@@ -1,6 +1,5 @@
-# Copyright 1999-2016 Gentoo Foundation
+# Copyright 1999-2018 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-# $Id $
EAPI=5
diff --git a/sys-libs/libcxx/libcxx-3.8.1.ebuild b/sys-libs/libcxx/libcxx-3.8.1.ebuild
index 10fac31054..47ba26312d 100644
--- a/sys-libs/libcxx/libcxx-3.8.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.8.1.ebuild
@@ -1,6 +1,5 @@
-# Copyright 1999-2016 Gentoo Foundation
+# Copyright 1999-2018 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-# $Id $
EAPI=5
diff --git a/sys-libs/libcxx/libcxx-3.9.1.ebuild b/sys-libs/libcxx/libcxx-3.9.1.ebuild
index b401a82aab..9bc41644b0 100644
--- a/sys-libs/libcxx/libcxx-3.9.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.9.1.ebuild
@@ -1,6 +1,5 @@
-# Copyright 1999-2017 Gentoo Foundation
+# Copyright 1999-2018 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-# $Id$
EAPI=6
diff --git a/sys-libs/libcxx/libcxx-5.0.1.ebuild b/sys-libs/libcxx/libcxx-5.0.1.ebuild
index 2aaca9ae4f..b498d154ad 100644
--- a/sys-libs/libcxx/libcxx-5.0.1.ebuild
+++ b/sys-libs/libcxx/libcxx-5.0.1.ebuild
@@ -1,6 +1,5 @@
# Copyright 1999-2018 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-# $Id$
EAPI=6
^ permalink raw reply related [flat|nested] 12+ messages in thread
* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2018-01-09 7:55 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2018-01-09 7:55 UTC (permalink / raw
To: gentoo-commits
commit: ff95ac820b05774786ead3ea8df4255bb0501218
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Tue Jan 9 07:53:24 2018 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Tue Jan 9 07:53:24 2018 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=ff95ac82
sys-libs/libcxx: marked 3.5.1 ~ppc-macos
Package-Manager: Portage-2.3.18-prefix, Repoman-2.3.6
sys-libs/libcxx/libcxx-3.5.1.ebuild | 6 +-----
1 file changed, 1 insertion(+), 5 deletions(-)
diff --git a/sys-libs/libcxx/libcxx-3.5.1.ebuild b/sys-libs/libcxx/libcxx-3.5.1.ebuild
index 66c8c8f018..0de443a4e4 100644
--- a/sys-libs/libcxx/libcxx-3.5.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.5.1.ebuild
@@ -21,11 +21,7 @@ fi
LICENSE="|| ( UoI-NCSA MIT )"
SLOT="0"
-if [ "${PV%9999}" = "${PV}" ] ; then
- KEYWORDS="~x64-macos ~x86-macos"
-else
- KEYWORDS=""
-fi
+KEYWORDS="~ppc-macos ~x64-macos ~x86-macos"
IUSE="elibc_glibc +libcxxrt static-libs test"
REQUIRED_USE="kernel_Darwin? ( libcxxrt !static-libs )"
^ permalink raw reply related [flat|nested] 12+ messages in thread
* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2018-01-09 14:46 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2018-01-09 14:46 UTC (permalink / raw
To: gentoo-commits
commit: 25e1006d17d8dee337d0f68e6449d41330e3e957
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Tue Jan 9 14:46:30 2018 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Tue Jan 9 14:46:30 2018 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=25e1006d
sys-libs/libcxx: drop obsolete patch
Package-Manager: Portage-2.3.18-prefix, Repoman-2.3.6
sys-libs/libcxx/libcxx-3.8.1.ebuild | 3 ---
1 file changed, 3 deletions(-)
diff --git a/sys-libs/libcxx/libcxx-3.8.1.ebuild b/sys-libs/libcxx/libcxx-3.8.1.ebuild
index 47ba26312d..df64d3fe6f 100644
--- a/sys-libs/libcxx/libcxx-3.8.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.8.1.ebuild
@@ -74,9 +74,6 @@ src_prepare() {
if [[ ${CHOST} == *darwin* ]] ; then
epatch "${FILESDIR}"/${PN}-3.5.1-olddarwin.patch
- [[ "${CHOST##*-darwin}" -le 10 ]] && \
- epatch "${FILESDIR}"/${PN}-3.5.1-cmath-conv.patch
-
# libc++abi needs stack unwinding functions provided by libSystem on
# Mac OS X >= 10.6. On < 10.6 they're in libgcc_s. So force link
# against that. Additionally, the crt1.o provided by our gcc-apple
^ permalink raw reply related [flat|nested] 12+ messages in thread
* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2018-01-10 19:11 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2018-01-10 19:11 UTC (permalink / raw
To: gentoo-commits
commit: 253aea5a6f65517d4a88d5a0c0cd6e9272610f65
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Wed Jan 10 19:11:01 2018 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Wed Jan 10 19:11:01 2018 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=253aea5a
sys-libs/libcxx: port ppc buildfix from 3.5.1 to 3.8.1
Package-Manager: Portage-2.3.18-prefix, Repoman-2.3.6
sys-libs/libcxx/libcxx-3.8.1.ebuild | 4 ++++
1 file changed, 4 insertions(+)
diff --git a/sys-libs/libcxx/libcxx-3.8.1.ebuild b/sys-libs/libcxx/libcxx-3.8.1.ebuild
index df64d3fe6f..61e7ba5bf6 100644
--- a/sys-libs/libcxx/libcxx-3.8.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.8.1.ebuild
@@ -94,6 +94,10 @@ src_prepare() {
epatch "${FILESDIR}"/${PN}-3.5.1-eprintf.patch
fi
+ if [[ ${CHOST} == powerpc*-darwin* ]] ; then
+ sed -i -e '/RC_CFLAGS=""/s/""/"-fPIC"/' lib/buildit || die
+ fi
+
# fix library install names
sed -i \
-e "s,/usr/lib/libc++abi\.dylib,${EPREFIX}/usr/lib/libc++abi.dylib,g" \
^ permalink raw reply related [flat|nested] 12+ messages in thread
* [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/
@ 2018-10-16 19:08 Fabian Groffen
0 siblings, 0 replies; 12+ messages in thread
From: Fabian Groffen @ 2018-10-16 19:08 UTC (permalink / raw
To: gentoo-commits
commit: 31dc8d7343df340b803f167a408d6c0ad902faf0
Author: Fabian Groffen <grobian <AT> gentoo <DOT> org>
AuthorDate: Tue Oct 16 19:07:30 2018 +0000
Commit: Fabian Groffen <grobian <AT> gentoo <DOT> org>
CommitDate: Tue Oct 16 19:08:15 2018 +0000
URL: https://gitweb.gentoo.org/repo/proj/prefix.git/commit/?id=31dc8d73
sys-libs/libcxx: EAPI 5->6
Signed-off-by: Fabian Groffen <grobian <AT> gentoo.org>
Package-Manager: Portage-2.3.40.3-prefix, Repoman-2.3.9
sys-libs/libcxx/libcxx-3.5.1.ebuild | 6 ++++--
sys-libs/libcxx/libcxx-3.7.1.ebuild | 6 ++++--
sys-libs/libcxx/libcxx-3.8.1.ebuild | 6 ++++--
3 files changed, 12 insertions(+), 6 deletions(-)
diff --git a/sys-libs/libcxx/libcxx-3.5.1.ebuild b/sys-libs/libcxx/libcxx-3.5.1.ebuild
index 8a27c5d416..2ad15f10d6 100644
--- a/sys-libs/libcxx/libcxx-3.5.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.5.1.ebuild
@@ -1,13 +1,13 @@
# Copyright 1999-2018 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-EAPI=5
+EAPI=6
ESVN_REPO_URI="http://llvm.org/svn/llvm-project/libcxx/trunk"
[ "${PV%9999}" != "${PV}" ] && SCM="subversion" || SCM=""
-inherit ${SCM} flag-o-matic toolchain-funcs multilib multilib-minimal
+inherit ${SCM} flag-o-matic toolchain-funcs multilib multilib-minimal epatch
DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
HOMEPAGE="http://libcxx.llvm.org/"
@@ -104,6 +104,8 @@ src_prepare() {
lib/buildit
fi
+ eapply_user
+
multilib_copy_sources
}
diff --git a/sys-libs/libcxx/libcxx-3.7.1.ebuild b/sys-libs/libcxx/libcxx-3.7.1.ebuild
index 47ba26312d..a12d949398 100644
--- a/sys-libs/libcxx/libcxx-3.7.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.7.1.ebuild
@@ -1,13 +1,13 @@
# Copyright 1999-2018 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-EAPI=5
+EAPI=6
ESVN_REPO_URI="http://llvm.org/svn/llvm-project/libcxx/trunk"
[ "${PV%9999}" != "${PV}" ] && SCM="subversion" || SCM=""
-inherit ${SCM} flag-o-matic toolchain-funcs multilib multilib-minimal
+inherit ${SCM} flag-o-matic toolchain-funcs multilib multilib-minimal epatch
DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
HOMEPAGE="http://libcxx.llvm.org/"
@@ -104,6 +104,8 @@ src_prepare() {
lib/buildit
fi
+ eapply_user
+
multilib_copy_sources
}
diff --git a/sys-libs/libcxx/libcxx-3.8.1.ebuild b/sys-libs/libcxx/libcxx-3.8.1.ebuild
index 61e7ba5bf6..f8f1518a6f 100644
--- a/sys-libs/libcxx/libcxx-3.8.1.ebuild
+++ b/sys-libs/libcxx/libcxx-3.8.1.ebuild
@@ -1,13 +1,13 @@
# Copyright 1999-2018 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
-EAPI=5
+EAPI=6
ESVN_REPO_URI="http://llvm.org/svn/llvm-project/libcxx/trunk"
[ "${PV%9999}" != "${PV}" ] && SCM="subversion" || SCM=""
-inherit ${SCM} flag-o-matic toolchain-funcs multilib multilib-minimal
+inherit ${SCM} flag-o-matic toolchain-funcs multilib multilib-minimal epatch
DESCRIPTION="New implementation of the C++ standard library, targeting C++11"
HOMEPAGE="http://libcxx.llvm.org/"
@@ -105,6 +105,8 @@ src_prepare() {
lib/buildit
fi
+ eapply_user
+
multilib_copy_sources
}
^ permalink raw reply related [flat|nested] 12+ messages in thread
end of thread, other threads:[~2018-10-16 19:08 UTC | newest]
Thread overview: 12+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2018-01-10 19:11 [gentoo-commits] repo/proj/prefix:master commit in: sys-libs/libcxx/ Fabian Groffen
-- strict thread matches above, loose matches on Subject: below --
2018-10-16 19:08 Fabian Groffen
2018-01-09 14:46 Fabian Groffen
2018-01-09 7:55 Fabian Groffen
2018-01-09 7:55 Fabian Groffen
2018-01-08 19:59 Fabian Groffen
2018-01-02 16:21 Fabian Groffen
2018-01-02 16:21 Fabian Groffen
2016-09-07 7:35 Fabian Groffen
2016-02-11 9:41 Fabian Groffen
2016-02-11 9:41 Fabian Groffen
2016-02-11 9:28 Fabian Groffen
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox